/*== include ==*/
#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<iostream>
#include<random>
#include<chrono>
#include<vector>
#include<cstring>

#ifdef _MSC_VER
#include <Windows.h>
#include <intrin.h>
#include <immintrin.h>
#include <wmmintrin.h>
#define cpuid    __cpuid
#else
#include <x86intrin.h>
//  GCC Inline Assembly
inline void __cpuid(int CPUInfo[4], int InfoType) {
	__asm__ __volatile__(
		"cpuid":
	"=a" (CPUInfo[0]),
		"=b" (CPUInfo[1]),
		"=c" (CPUInfo[2]),
		"=d" (CPUInfo[3]) :
		"a" (InfoType)
		);
}
#endif

// standard library
using namespace std;


/*== alignment ==*/
#ifdef _MSC_VER
#define MIE_ALIGN(x) __declspec(align(x))
#else
#define MIE_ALIGN(x) __attribute__((aligned(x)))
#endif


/*==== AES-CTR ====*/
void aesctr_set_up(const unsigned char* k);
void aesctr_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);
void aesctr_gray_set_up(const unsigned char* k);
void aesctr_gray_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);


/*==== AES-PRF ====*/
void aesprf_set_up(const unsigned char* k);
void aesprf_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);
void aesprf_gray_set_up(const unsigned char* k);
void aesprf_gray_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);



/*==== ZIP-AES ====*/
void zipaes_set_up(const unsigned char* k);
void zipaes_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);

void zipaes_gray_set_up(const unsigned char* k);
void zipaes_gray_enc(
  const unsigned char* _K,     // Secret key                
  const unsigned char* _N,     // Nonce                     
  const unsigned char* _M,     // Message                   
  unsigned long long   _mlen,  // Length of Message         
  unsigned char* C_            // Ciphertext               
);



/*==== experiments for differential-linear ====*/
double experimentDifferentialLinear(void);


/*==== experiments for differential and linear ====*/
double experimentDifferentialAndLinear(bool rightGuess = true);